# /u/sy/beebe/src/lex/ndtos/fmtfun3.awk, Mon May 11 12:44:37 1992
# Edit by Nelson H. F. Beebe <beebe@sandy.math.utah.edu>
# ========================================================================
# Format linpack.names file into lex code for precision conversion
# The file contains complex, double, single, and double complex
# names.  A ? in a field indicates that there is no corresponding
# function.  This is used in the lexer (in cvtstr()) to issue
# warnings about unconvertible names.
#
# Usage:
#	nawk -f fmtfun3.awk linpack.names >dtos-code
#	nawk -f fmtfun3.awk "dtos = 0" linpack.names >stod-code
#
# [06-Apr-1991]
# ========================================================================

BEGIN {dtos = 1}

/^#/	{}		# ignore comments

NF == 4 {
    cname = $1;
    dname = $2;
    sname = $3;
    zname = $4;
    
    if ((sname != "?") || (dname != "?"))
	pair(dname,sname);
    
    if ((cname != "?") || (zname != "?"))
	pair(zname,cname);
}

function cvtstr(s,t, k)
{
    for (k = 1; k <= length(s); ++k)
	printf("{%s}",substr(s,k,1));
    printf("/{W}(");		# lookahead string
    for (k = 5 + length(s)*3; k < 32; ++k)
	printf(" ");
    print "cvtstr(\"" t "\");";    
}

function innerpair(s,t, k)
{
    if (s == "?")
	;			# ignore unknown source patterns
    else if (t == "?")
	cvtstr(s,"?" s);
    else
	cvtstr(s,t);
}

function pair(s,t)
{
    if (dtos)
        innerpair(s,t);
    else
        innerpair(t,s);
}
